python-all-dev, python-dev must be Arch: any for multiarch

Bug #934593 reported by Steve Langasek
26
This bug affects 4 people
Affects Status Importance Assigned to Milestone
python-defaults (Ubuntu)
Medium
Unassigned
Precise
Medium
Unassigned
Raring
Medium
Unassigned
python3-defaults (Ubuntu)
Undecided
Unassigned
Precise
Undecided
Unassigned
Raring
Undecided
Unassigned

Bug Description

The python-all-dev and python-dev packages are currently Architecture: all. This makes them unusable for cross-building python extension packages, because these then get treated as packages of the native architecture, pulling in the native python2.7-dev / libpython2.7 instead of the host-arch one that we need.

Making them Architecture: any is a prerequisite for being able to grab python-all-dev:armhf (for instance) as a build-dependency. More work beyond that will be needed to make this usable though, since libpython2.7 has a dependency on python2.7 (why?) and we can't replace the native python with the host one for a cross build.

ProblemType: Bug
DistroRelease: Ubuntu 12.04
Package: python-all-dev (not installed)
ProcVersionSignature: Ubuntu 3.2.0-16.25-generic 3.2.6
Uname: Linux 3.2.0-16-generic x86_64
ApportVersion: 1.91-0ubuntu1
Architecture: amd64
CheckboxSubmission: 017452a27eca3c8b498abbfa5ef91db9
CheckboxSystem: ecaaad6fa1e0799a0aa1126bf620f39e
Date: Fri Feb 17 15:44:26 2012
InstallationMedia: Ubuntu 10.04.1 LTS "Lucid Lynx" - Release amd64 (20100816.1)
ProcEnviron:
 PATH=(custom, user)
 LANG=en_US.UTF-8
 SHELL=/bin/bash
SourcePackage: python-defaults
UpgradeStatus: Upgraded to precise on 2011-11-08 (101 days ago)

Steve Langasek (vorlon)
Changed in python-defaults (Ubuntu):
importance: Undecided → Low
Revision history for this message
Matthias Klose (doko) wrote :

libpython2.7 contains the shared library only, not any of the python modules. at least a part of the standard library is necessary for the libpython library.

plus python itself is not ready for multiarch yet.

Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package python-defaults - 2.7.2-9ubuntu3

---------------
python-defaults (2.7.2-9ubuntu3) precise; urgency=low

  * Build dependency packages as architecture dependent packages. LP: #934593.
  * Provide python2 and python2-config symlinks.
 -- Matthias Klose <email address hidden> Fri, 16 Mar 2012 02:36:04 +0100

Changed in python-defaults (Ubuntu):
status: New → Fix Released
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package python3-defaults - 3.2.3~rc1-1ubuntu1

---------------
python3-defaults (3.2.3~rc1-1ubuntu1) precise; urgency=low

  * Build dependency packages as architecture dependent packages. LP: #934593.
 -- Matthias Klose <email address hidden> Fri, 16 Mar 2012 02:56:31 +0100

Changed in python3-defaults (Ubuntu):
status: New → Fix Released
Revision history for this message
Micah Gersten (micahg) wrote :

I had to revert this upload as it made python uninstallable on !i386 due to build skew. Not sure why the arch all binary was deleted before the arch specific binaries were built.

Changed in python-defaults (Ubuntu):
status: Fix Released → Triaged
Revision history for this message
Micah Gersten (micahg) wrote :

Both uploads reverted as they seemed to be co-dependent

Changed in python3-defaults (Ubuntu):
status: Fix Released → Triaged
Revision history for this message
Micah Gersten (micahg) wrote :

Apologies, python3-defaults was fine, so I reuploaded that. After speaking with infinity, it seems that python-defaults just needs to be done in one publisher cycle or !i386 needs to build before the i386 binaries are published. slangasek also mentioned that not the whole source needed to be arch:any, might be worth having a discussion about this.

Changed in python3-defaults (Ubuntu):
status: Triaged → Fix Released
Revision history for this message
Steve Langasek (vorlon) wrote : Re: [Bug 934593] Re: python-all-dev, python-dev must be Arch: any for multiarch

On Fri, Mar 16, 2012 at 07:47:54AM -0000, Micah Gersten wrote:
> Apologies, python3-defaults was fine, so I reuploaded that. After
> speaking with infinity, it seems that python-defaults just needs to be
> done in one publisher cycle or !i386 needs to build before the i386
> binaries are published. slangasek also mentioned that not the whole
> source needed to be arch:any, might be worth having a discussion about
> this.

I haven't looked closely at the dependencies to see why python was changed
to Arch: any. From a top-level POV, the only packages I was concerned with
were the -dev packages; it's entirely possible that python also has to be
Arch: any to make any use of those.

--
Steve Langasek Give me a lever long enough and a Free OS
Debian Developer to set it on, and I can move the world.
Ubuntu Developer http://www.debian.org/
<email address hidden> <email address hidden>

Revision history for this message
Scott Kitterman (kitterman) wrote :

Can this be deferred to "Q"? Given the libpython issue and the fact that Python itself is not ready for multi-arch, is this change going to produce anything useful for precise?

Revision history for this message
Steve Langasek (vorlon) wrote :

The utility here is to allow satisfying cross-build-deps of packages that build python extensions. I don't know if Matthias's comment that "python itself is not ready for multiarch yet" is related to this, or if he's referring to the fact that python extension packages aren't coinstallable (which is not at all what I'm looking for right now).

Revision history for this message
Matthias Klose (doko) wrote :

proposing for precise-proposed, test build available in
https://launchpad.net/~doko/+archive/toolchain/+packages

test upgrades work fine.

Changed in python-defaults (Ubuntu):
importance: Low → Medium
Revision history for this message
Steve Langasek (vorlon) wrote : Please test proposed package

Hello Steve, or anyone else affected,

Accepted python-defaults into precise-proposed. The package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

Changed in python-defaults (Ubuntu Precise):
status: Triaged → Fix Committed
tags: added: verification-needed
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package python-defaults - 2.7.3-0ubuntu2

---------------
python-defaults (2.7.3-0ubuntu2) precise-proposed; urgency=low

  * Re-add the python2 and python2-config symlinks, formerly present
    in the python2.7 packages. PEP 394.
  * Build dependency packages as architecture dependent packages again.
    LP: #934593.
  * Move idle.xpm into the idle package.
  * Stop providing python-argparse (also provided by python2.7).
 -- Matthias Klose <email address hidden> Tue, 17 Apr 2012 15:54:22 +0200

Changed in python-defaults (Ubuntu Precise):
status: Fix Committed → Fix Released
Wookey (wookey)
tags: added: cross multiarch
removed: verification-needed
Revision history for this message
Jean-Luc Aufranc (jean-luc-aufranc) wrote :

I've tried it for armel.
Added
deb [arch=armel,armhf] http://ports.ubuntu.com/ubuntu-ports precise-proposed main universe multiverse restricted to /etc/apt/source.lists

Then ran:
sudo apt-get update
sudo apt-get install -t precise-proposed python:armel

The following packages have unmet dependencies:
 python:armel : Depends: python2.7:armel (>= 2.7.3) but it is not going to be installed
E: Unable to correct problems, you have held broken packages.

I've tracked to mime-support
sudo apt-get install -t precise-proposed mime-support:armel
Reading package lists... Done
Building dependency tree
Reading state information... Done
Package mime-support:armel is not available, but is referred to by another package.
This may mean that the package is missing, has been obsoleted, or
is only available from another source

E: Package 'mime-support:armel' has no installation candidate

Steve Langasek (vorlon)
Changed in python3-defaults (Ubuntu):
status: Fix Released → Triaged
Changed in python-defaults (Ubuntu):
status: Fix Released → Triaged
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package python-defaults - 2.7.3-3ubuntu2

---------------
python-defaults (2.7.3-3ubuntu2) raring; urgency=low

  * debian/control.in: move python-docutils, and debiandoc-sgml to
    Build-Depends from B-D-Indep. This fixes build failures with
    --no-arch-all and in the buildds on powerpc, armhf, and amd64.
 -- Barry Warsaw <email address hidden> Wed, 28 Nov 2012 17:04:08 -0500

Changed in python-defaults (Ubuntu Raring):
status: Triaged → Fix Released
Revision history for this message
Steve Langasek (vorlon) wrote :

Fixed in raring:

 python3-defaults (3.3.0-0ubuntu1) raring; urgency=low

  [ Dmitrijs Ledkovs ]
  * Make python3.3 default.

  [ Matthias Klose ]
  * Build dependency packages as architecture dependent packages.
  * Ship the pkgconfig symlinks again.

 -- Matthias Klose <email address hidden> Fri, 26 Oct 2012 16:44:58 +0200

Changed in python3-defaults (Ubuntu Raring):
status: Triaged → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers